<html>
<head>
<title>OgreCompositor.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositor.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositor_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Compositor_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Compositor_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00049"></a><a class="code" href="classOgre_1_1Compositor.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00053"></a>00053             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00054"></a>00054         ~<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>();
<a name="l00055"></a>00055         
<a name="l00057"></a><a class="code" href="classOgre_1_1Compositor.html#abec9971d39d3c5a8109480ee4ab687c7">00057</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CompositionTechnique *&gt;::type</a> <a class="code" href="classOgre_1_1Compositor.html#abec9971d39d3c5a8109480ee4ab687c7" title="Data types for internal lists.">Techniques</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1Compositor.html#acc029ae8cf6f0db569d8328621c6cd50">00058</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;Techniques&gt;</a> <a class="code" href="classOgre_1_1Compositor.html#acc029ae8cf6f0db569d8328621c6cd50">TechniqueIterator</a>;
<a name="l00059"></a>00059         
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *createTechnique();
<a name="l00063"></a>00063         
<a name="l00066"></a>00066         <span class="keywordtype">void</span> removeTechnique(<span class="keywordtype">size_t</span> idx);
<a name="l00067"></a>00067         
<a name="l00070"></a>00070         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *getTechnique(<span class="keywordtype">size_t</span> idx);
<a name="l00071"></a>00071         
<a name="l00074"></a>00074         <span class="keywordtype">size_t</span> getNumTechniques();
<a name="l00075"></a>00075         
<a name="l00078"></a>00078         <span class="keywordtype">void</span> removeAllTechniques();
<a name="l00079"></a>00079         
<a name="l00081"></a>00081         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">TechniqueIterator</a> getTechniqueIterator(<span class="keywordtype">void</span>);
<a name="l00082"></a>00082         
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *getSupportedTechnique(<span class="keywordtype">size_t</span> idx);
<a name="l00090"></a>00090         
<a name="l00097"></a>00097         <span class="keywordtype">size_t</span> getNumSupportedTechniques();
<a name="l00098"></a>00098         
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">TechniqueIterator</a> getSupportedTechniqueIterator(<span class="keywordtype">void</span>);
<a name="l00106"></a>00106 
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *getSupportedTechnique(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00115"></a>00115 
<a name="l00121"></a>00121         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTextureInstanceName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> mrtIndex);
<a name="l00122"></a>00122 
<a name="l00128"></a>00128         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> getTextureInstance(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> mrtIndex);
<a name="l00129"></a>00129 
<a name="l00136"></a>00136         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* getRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keyword">protected</span>:
<a name="l00140"></a>00140         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00141"></a>00141 
<a name="l00143"></a>00143         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00145"></a>00145         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00146"></a>00146         
<a name="l00149"></a>00149         <span class="keywordtype">void</span> compile();
<a name="l00150"></a>00150     <span class="keyword">private</span>:
<a name="l00151"></a><a class="code" href="classOgre_1_1Compositor.html#ad4708ad02433e679c0e177c2057d1abc">00151</a>         <a class="code" href="classOgre_1_1Compositor.html#abec9971d39d3c5a8109480ee4ab687c7" title="Data types for internal lists.">Techniques</a> <a class="code" href="classOgre_1_1Compositor.html#ad4708ad02433e679c0e177c2057d1abc">mTechniques</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1Compositor.html#a0acfaa665d97599e8bddc0e800f0a4f7">00152</a>         <a class="code" href="classOgre_1_1Compositor.html#abec9971d39d3c5a8109480ee4ab687c7" title="Data types for internal lists.">Techniques</a> <a class="code" href="classOgre_1_1Compositor.html#a0acfaa665d97599e8bddc0e800f0a4f7">mSupportedTechniques</a>;
<a name="l00153"></a>00153         
<a name="l00157"></a><a class="code" href="classOgre_1_1Compositor.html#aec85ffc8a8d68c64e88dcd1efbfe601e">00157</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Compositor.html#aec85ffc8a8d68c64e88dcd1efbfe601e" title="Compilation required This is set if the techniques change and the supportedness of techniques has to ...">mCompilationRequired</a>;
<a name="l00158"></a>00158 
<a name="l00161"></a>00161         <span class="keywordtype">void</span> createGlobalTextures();
<a name="l00162"></a>00162         
<a name="l00165"></a>00165         <span class="keywordtype">void</span> freeGlobalTextures();
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <span class="comment">//TODO GSOC : These typedefs are duplicated from CompositorInstance. Solve?</span>
<a name="l00169"></a><a class="code" href="classOgre_1_1Compositor.html#a0e0170a318c84a29f938d5d6ac332fe4">00169</a> <span class="comment"></span>        <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String,TexturePtr&gt;::type</a> <a class="code" href="classOgre_1_1Compositor.html#a0e0170a318c84a29f938d5d6ac332fe4" title="Map from name-&gt;local texture.">GlobalTextureMap</a>;
<a name="l00170"></a><a class="code" href="classOgre_1_1Compositor.html#a146f3140c881fa25c8b70e514a861996">00170</a>         <a class="code" href="classOgre_1_1Compositor.html#a0e0170a318c84a29f938d5d6ac332fe4" title="Map from name-&gt;local texture.">GlobalTextureMap</a> <a class="code" href="classOgre_1_1Compositor.html#a146f3140c881fa25c8b70e514a861996">mGlobalTextures</a>;
<a name="l00172"></a><a class="code" href="classOgre_1_1Compositor.html#a9680f81fbcd3454ec68b95bdd9b2bc9b">00172</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String,MultiRenderTarget*&gt;::type</a> <a class="code" href="classOgre_1_1Compositor.html#a9680f81fbcd3454ec68b95bdd9b2bc9b" title="Store a list of MRTs we&#39;ve created.">GlobalMRTMap</a>;
<a name="l00173"></a><a class="code" href="classOgre_1_1Compositor.html#a0cc5bc90062a4cedb7bea0b58e393502">00173</a>         <a class="code" href="classOgre_1_1Compositor.html#a9680f81fbcd3454ec68b95bdd9b2bc9b" title="Store a list of MRTs we&#39;ve created.">GlobalMRTMap</a> <a class="code" href="classOgre_1_1Compositor.html#a0cc5bc90062a4cedb7bea0b58e393502">mGlobalMRTs</a>;
<a name="l00174"></a>00174     };
<a name="l00175"></a>00175 
<a name="l00182"></a><a class="code" href="classOgre_1_1CompositorPtr.html">00182</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to CompositorPtr.">CompositorPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Compositor&gt; 
<a name="l00183"></a>00183     {
<a name="l00184"></a>00184     <span class="keyword">public</span>:
<a name="l00185"></a><a class="code" href="classOgre_1_1CompositorPtr.html#aa3eee7fa37dfcb2456a55abf5a1f9a7f">00185</a>         <a class="code" href="classOgre_1_1CompositorPtr.html#aa3eee7fa37dfcb2456a55abf5a1f9a7f">CompositorPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>&gt;() {}
<a name="l00186"></a><a class="code" href="classOgre_1_1CompositorPtr.html#a54adde79525ae8f1cb78b1e5c2b89fde">00186</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1CompositorPtr.html#a54adde79525ae8f1cb78b1e5c2b89fde">CompositorPtr</a>(<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>&gt;(rep) {}
<a name="l00187"></a><a class="code" href="classOgre_1_1CompositorPtr.html#a5cc6d22999daaa7d45bad2240949aad3">00187</a>         <a class="code" href="classOgre_1_1CompositorPtr.html#a5cc6d22999daaa7d45bad2240949aad3">CompositorPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1CompositorPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to CompositorPtr.">CompositorPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>&gt;(r) {} 
<a name="l00188"></a><a class="code" href="classOgre_1_1CompositorPtr.html#a168ffea5194098e0c027bbae98770e0a">00188</a>         <a class="code" href="classOgre_1_1CompositorPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to CompositorPtr.">CompositorPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>&gt;()
<a name="l00189"></a>00189         {
<a name="l00190"></a>00190             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00191"></a>00191             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00192"></a>00192             {
<a name="l00193"></a>00193                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00194"></a>00194                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00195"></a>00195                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00196"></a>00196                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00197"></a>00197                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00198"></a>00198                 {
<a name="l00199"></a>00199                     ++(*pUseCount);
<a name="l00200"></a>00200                 }
<a name="l00201"></a>00201             }
<a name="l00202"></a>00202         }
<a name="l00203"></a>00203 
<a name="l00205"></a><a class="code" href="classOgre_1_1CompositorPtr.html#a49e481010170b8cfa6a1b6367d3b7551">00205</a>         <a class="code" href="classOgre_1_1CompositorPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to CompositorPtr.">CompositorPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00206"></a>00206         {
<a name="l00207"></a>00207             <span class="keywordflow">if</span> (pRep == static_cast&lt;Compositor*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00208"></a>00208                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00209"></a>00209             release();
<a name="l00210"></a>00210             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00211"></a>00211             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00212"></a>00212             {
<a name="l00213"></a>00213                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00214"></a>00214                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00215"></a>00215                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00216"></a>00216                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00217"></a>00217                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00218"></a>00218                 {
<a name="l00219"></a>00219                     ++(*pUseCount);
<a name="l00220"></a>00220                 }
<a name="l00221"></a>00221             }
<a name="l00222"></a>00222             <span class="keywordflow">else</span>
<a name="l00223"></a>00223             {
<a name="l00224"></a>00224                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00225"></a>00225                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00226"></a>00226                 setNull();
<a name="l00227"></a>00227             }
<a name="l00228"></a>00228             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230     };
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
